import{S as Xi,i as Bi,s as Fi,e as a,k as h,w as v,t as n,M as zi,c as i,d as o,m as c,a as r,x as w,h as s,b as f,G as t,g as p,y as E,q as y,o as $,B as O,v as Gi}from"../../../../chunks/vendor-hf-doc-builder.js";import{T as ya}from"../../../../chunks/Tip-hf-doc-builder.js";import{I as Se}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{C as J}from"../../../../chunks/CodeBlock-hf-doc-builder.js";function Ui(K){let u,j,d,x,N,m,_,A;return{c(){u=a("p"),j=n(`A good way to implement a custom ONNX configuration is to look at the existing configuration implementations in the
`),d=a("code"),x=n("optimum/exporters/onnx/model_configs.py"),N=n(" file."),m=h(),_=a("p"),A=n(`Also, if the architecture you are trying to add is (very) similar to an architecture that is already supported
(for instance adding support for ALBERT when BERT is already supported), trying to simply inheriting from this class
might work.`)},l(g){u=i(g,"P",{});var T=r(u);j=s(T,`A good way to implement a custom ONNX configuration is to look at the existing configuration implementations in the
`),d=i(T,"CODE",{});var L=r(d);x=s(L,"optimum/exporters/onnx/model_configs.py"),L.forEach(o),N=s(T," file."),T.forEach(o),m=c(g),_=i(g,"P",{});var R=r(_);A=s(R,`Also, if the architecture you are trying to add is (very) similar to an architecture that is already supported
(for instance adding support for ALBERT when BERT is already supported), trying to simply inheriting from this class
might work.`),R.forEach(o)},m(g,T){p(g,u,T),t(u,j),t(u,d),t(d,x),t(u,N),p(g,m,T),p(g,_,T),t(_,A)},d(g){g&&o(u),g&&o(m),g&&o(_)}}}function Hi(K){let u,j,d,x,N;return{c(){u=a("p"),j=n("Check out "),d=a("code"),x=n("BartOnnxConfig"),N=n(" for an advanced example.")},l(m){u=i(m,"P",{});var _=r(u);j=s(_,"Check out "),d=i(_,"CODE",{});var A=r(d);x=s(A,"BartOnnxConfig"),A.forEach(o),N=s(_," for an advanced example."),_.forEach(o)},m(m,_){p(m,u,_),t(u,j),t(u,d),t(d,x),t(u,N)},d(m){m&&o(u)}}}function Yi(K){let u,j,d,x,N,m,_,A,g,T,L;return{c(){u=a("p"),j=n(`If your model is larger than 2GB, you will see that many additional files are created during the export. This is
`),d=a("em"),x=n("expected"),N=n(" because ONNX uses "),m=a("a"),_=n("Protocol Buffers"),A=n(` to store the model
and these have a size limit of 2GB. See the `),g=a("a"),T=n("ONNX documentation"),L=n(`
for instructions on how to load models with external data.`),this.h()},l(R){u=i(R,"P",{});var q=r(u);j=s(q,`If your model is larger than 2GB, you will see that many additional files are created during the export. This is
`),d=i(q,"EM",{});var D=r(d);x=s(D,"expected"),D.forEach(o),N=s(q," because ONNX uses "),m=i(q,"A",{href:!0,rel:!0});var Q=r(m);_=s(Q,"Protocol Buffers"),Q.forEach(o),A=s(q,` to store the model
and these have a size limit of 2GB. See the `),g=i(q,"A",{href:!0,rel:!0});var Le=r(g);T=s(Le,"ONNX documentation"),Le.forEach(o),L=s(q,`
for instructions on how to load models with external data.`),q.forEach(o),this.h()},h(){f(m,"href","https://developers.google.com/protocol-buffers/"),f(m,"rel","nofollow"),f(g,"href","https://github.com/onnx/onnx/blob/master/docs/ExternalData.md"),f(g,"rel","nofollow")},m(R,q){p(R,u,q),t(u,j),t(u,d),t(d,x),t(u,N),t(u,m),t(m,_),t(u,A),t(u,g),t(g,T),t(u,L)},d(R){R&&o(u)}}}function Vi(K){let u,j,d,x,N,m,_,A,g,T,L,R,q,D,Q,Le,sn,xe,an,Re,rn,ln,pn,lt,hn,cn,pt,fn,oo,Me,un,no,U,ee,ht,ve,dn,ct,mn,so,te,gn,Xe,_n,xn,ao,oe,io,Be,vn,ro,H,ne,ft,we,wn,ut,En,lo,X,yn,Fe,$n,On,dt,bn,kn,po,Ee,ho,b,Nn,mt,Tn,jn,gt,An,Cn,_t,qn,Dn,ze,Pn,In,xt,Sn,Ln,vt,Rn,Mn,co,se,Xn,wt,Bn,Fn,fo,ae,ie,Et,zn,Gn,Ge,Un,Hn,Yn,Ue,yt,Vn,Wn,uo,k,Zn,He,Jn,Kn,$t,Qn,es,Ot,ts,os,bt,ns,ss,kt,as,is,Nt,rs,ls,mo,Ye,ps,go,ye,_o,Ve,hs,xo,$e,vo,We,cs,wo,Oe,Eo,P,fs,Tt,us,ds,jt,ms,gs,At,_s,xs,Ct,vs,ws,yo,be,$o,re,Oo,Y,le,qt,ke,Es,Dt,ys,bo,B,$s,Ze,Os,bs,Pt,ks,Ns,ko,pe,Ts,It,js,As,No,he,Ne,Cs,St,qs,Ds,Ps,Lt,Is,To,Je,Ss,jo,Te,Ao,V,ce,Rt,je,Ls,Mt,Rs,Co,F,Ms,Xt,Xs,Bs,Bt,Fs,zs,qo,Ae,Do,C,Gs,Ft,Us,Hs,zt,Ys,Vs,Gt,Ws,Zs,Ke,Js,Ks,Qe,Qs,ea,Po,Ce,Io,fe,So,W,ue,Ut,qe,ta,Ht,oa,Lo,z,na,Yt,sa,aa,Vt,ia,ra,Ro,De,Mo,Z,de,Wt,Pe,la,Zt,pa,Xo,et,ha,Bo,me,tt,ca,Jt,fa,ua,ot,da,ge,Kt,ma,ga,Fo,nt,_a,zo;return m=new Se({}),ve=new Se({}),oe=new ya({props:{$$slots:{default:[Ui]},$$scope:{ctx:K}}}),we=new Se({}),Ee=new J({props:{code:`# This class is actually in optimum/exporters/onnx/config.py
class TextEncoderOnnxConfig(OnnxConfig):
    # Describes how to generate the dummy inputs.
    DUMMY_INPUT_GENERATOR_CLASSES = (DummyTextInputGenerator,)

class BertOnnxConfig(TextEncoderOnnxConfig):
    # Specifies how to normalize the BertConfig, this is needed to access common attributes
    # during dummy input generation.
    NORMALIZED_CONFIG_CLASS = NormalizedTextConfig
    # Sets the absolute tolerance to when validating the exported ONNX model against the
    # reference model.
    ATOL_FOR_VALIDATION = 1e-4

    @property
    def inputs(self) -> Mapping[str, Mapping[int, str]]:
        if self.task == "multiple-choice":
            dynamic_axis = {0: "batch_size", 1: "num_choices", 2: "sequence_length"}
        else:
            dynamic_axis = {0: "batch_size", 1: "sequence_length"}
        return {
            "input_ids": dynamic_axis,
            "attention_mask": dynamic_axis,
            "token_type_ids": dynamic_axis,
        }`,highlighted:`<span class="hljs-comment"># This class is actually in optimum/exporters/onnx/config.py</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">TextEncoderOnnxConfig</span>(<span class="hljs-title class_ inherited__">OnnxConfig</span>):
    <span class="hljs-comment"># Describes how to generate the dummy inputs.</span>
    DUMMY_INPUT_GENERATOR_CLASSES = (DummyTextInputGenerator,)

<span class="hljs-keyword">class</span> <span class="hljs-title class_">BertOnnxConfig</span>(<span class="hljs-title class_ inherited__">TextEncoderOnnxConfig</span>):
    <span class="hljs-comment"># Specifies how to normalize the BertConfig, this is needed to access common attributes</span>
    <span class="hljs-comment"># during dummy input generation.</span>
    NORMALIZED_CONFIG_CLASS = NormalizedTextConfig
    <span class="hljs-comment"># Sets the absolute tolerance to when validating the exported ONNX model against the</span>
    <span class="hljs-comment"># reference model.</span>
    ATOL_FOR_VALIDATION = <span class="hljs-number">1e-4</span>

<span class="hljs-meta">    @property</span>
    <span class="hljs-keyword">def</span> <span class="hljs-title function_">inputs</span>(<span class="hljs-params">self</span>) -&gt; Mapping[<span class="hljs-built_in">str</span>, Mapping[<span class="hljs-built_in">int</span>, <span class="hljs-built_in">str</span>]]:
        <span class="hljs-keyword">if</span> self.task == <span class="hljs-string">&quot;multiple-choice&quot;</span>:
            dynamic_axis = {<span class="hljs-number">0</span>: <span class="hljs-string">&quot;batch_size&quot;</span>, <span class="hljs-number">1</span>: <span class="hljs-string">&quot;num_choices&quot;</span>, <span class="hljs-number">2</span>: <span class="hljs-string">&quot;sequence_length&quot;</span>}
        <span class="hljs-keyword">else</span>:
            dynamic_axis = {<span class="hljs-number">0</span>: <span class="hljs-string">&quot;batch_size&quot;</span>, <span class="hljs-number">1</span>: <span class="hljs-string">&quot;sequence_length&quot;</span>}
        <span class="hljs-keyword">return</span> {
            <span class="hljs-string">&quot;input_ids&quot;</span>: dynamic_axis,
            <span class="hljs-string">&quot;attention_mask&quot;</span>: dynamic_axis,
            <span class="hljs-string">&quot;token_type_ids&quot;</span>: dynamic_axis,
        }`}}),ye=new J({props:{code:`from transformers import AutoConfig

config = AutoConfig.from_pretrained("bert-base-uncased")
onnx_config = BertOnnxConfig(config)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoConfig

<span class="hljs-meta">&gt;&gt;&gt; </span>config = AutoConfig.from_pretrained(<span class="hljs-string">&quot;bert-base-uncased&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>onnx_config = BertOnnxConfig(config)`}}),$e=new J({props:{code:"print(onnx_config.DEFAULT_ONNX_OPSET)",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(onnx_config.DEFAULT_ONNX_OPSET)
<span class="hljs-number">11</span>`}}),Oe=new J({props:{code:"print(onnx_config.outputs)",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(onnx_config.outputs)
OrderedDict([(<span class="hljs-string">&quot;last_hidden_state&quot;</span>, {<span class="hljs-number">0</span>: <span class="hljs-string">&quot;batch_size&quot;</span>, <span class="hljs-number">1</span>: <span class="hljs-string">&quot;sequence_length&quot;</span>})])`}}),be=new J({props:{code:`from transformers import AutoConfig

config = AutoConfig.from_pretrained("bert-base-uncased")
onnx_config_for_seq_clf = BertOnnxConfig(config, task="sequence-classification")
print(onnx_config_for_seq_clf.outputs)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoConfig

<span class="hljs-meta">&gt;&gt;&gt; </span>config = AutoConfig.from_pretrained(<span class="hljs-string">&quot;bert-base-uncased&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>onnx_config_for_seq_clf = BertOnnxConfig(config, task=<span class="hljs-string">&quot;sequence-classification&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(onnx_config_for_seq_clf.outputs)
OrderedDict([(<span class="hljs-string">&#x27;logits&#x27;</span>, {<span class="hljs-number">0</span>: <span class="hljs-string">&#x27;batch_size&#x27;</span>})])`}}),re=new ya({props:{$$slots:{default:[Hi]},$$scope:{ctx:K}}}),ke=new Se({}),Te=new J({props:{code:`    "bert": supported_tasks_mapping(
        "default",
        "masked-lm",
        "causal-lm",
        "sequence-classification",
        "multiple-choice",
        "token-classification",
        "question-answering",
        onnx="BertOnnxConfig",
    )`,highlighted:`    <span class="hljs-string">&quot;bert&quot;</span>: supported_tasks_mapping(
        <span class="hljs-string">&quot;default&quot;</span>,
        <span class="hljs-string">&quot;masked-lm&quot;</span>,
        <span class="hljs-string">&quot;causal-lm&quot;</span>,
        <span class="hljs-string">&quot;sequence-classification&quot;</span>,
        <span class="hljs-string">&quot;multiple-choice&quot;</span>,
        <span class="hljs-string">&quot;token-classification&quot;</span>,
        <span class="hljs-string">&quot;question-answering&quot;</span>,
        onnx=<span class="hljs-string">&quot;BertOnnxConfig&quot;</span>,
    )`}}),je=new Se({}),Ae=new J({props:{code:`from pathlib import Path
from optimum.exporters import TasksManager
from optimum.exporters.onnx import export
from transformers import AutoModel

base_model = AutoModel.from_pretrained("bert-base-uncased")

onnx_path = Path("model.onnx")
onnx_config_constructor = TasksManager.get_exporter_config_constructor(base_model.config.model_type, "onnx")
onnx_config = onnx_config_constructor(base_model.config)

onnx_inputs, onnx_outputs = export(base_model, onnx_config, onnx_config.DEFAULT_ONNX_OPSET, onnx_path)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> pathlib <span class="hljs-keyword">import</span> Path
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.exporters <span class="hljs-keyword">import</span> TasksManager
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.exporters.onnx <span class="hljs-keyword">import</span> export
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModel

<span class="hljs-meta">&gt;&gt;&gt; </span>base_model = AutoModel.from_pretrained(<span class="hljs-string">&quot;bert-base-uncased&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>onnx_path = Path(<span class="hljs-string">&quot;model.onnx&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>onnx_config_constructor = TasksManager.get_exporter_config_constructor(base_model.config.model_type, <span class="hljs-string">&quot;onnx&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>onnx_config = onnx_config_constructor(base_model.config)

<span class="hljs-meta">&gt;&gt;&gt; </span>onnx_inputs, onnx_outputs = export(base_model, onnx_config, onnx_config.DEFAULT_ONNX_OPSET, onnx_path)`}}),Ce=new J({props:{code:`import onnx

onnx_model = onnx.load("model.onnx")
onnx.checker.check_model(onnx_model)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> onnx

<span class="hljs-meta">&gt;&gt;&gt; </span>onnx_model = onnx.load(<span class="hljs-string">&quot;model.onnx&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>onnx.checker.check_model(onnx_model)`}}),fe=new ya({props:{$$slots:{default:[Yi]},$$scope:{ctx:K}}}),qe=new Se({}),De=new J({props:{code:`from optimum.exporters.onnx import validate_model_outputs

validate_model_outputs(
    onnx_config, base_model, onnx_path, onnx_outputs, onnx_config.ATOL_FOR_VALIDATION
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.exporters.onnx <span class="hljs-keyword">import</span> validate_model_outputs

<span class="hljs-meta">&gt;&gt;&gt; </span>validate_model_outputs(
<span class="hljs-meta">... </span>    onnx_config, base_model, onnx_path, onnx_outputs, onnx_config.ATOL_FOR_VALIDATION
<span class="hljs-meta">... </span>)`}}),Pe=new Se({}),{c(){u=a("meta"),j=h(),d=a("h1"),x=a("a"),N=a("span"),v(m.$$.fragment),_=h(),A=a("span"),g=n("Adding support for an unsupported architecture"),T=h(),L=a("p"),R=n("If you wish to export a model whose architecture is not already supported by the library, these are the main steps to follow:"),q=h(),D=a("ol"),Q=a("li"),Le=n("Implement a custom ONNX configuration."),sn=h(),xe=a("li"),an=n("Register the ONNX configuration in the "),Re=a("a"),rn=n("TasksManager"),ln=n("."),pn=h(),lt=a("li"),hn=n("Export the model to ONNX."),cn=h(),pt=a("li"),fn=n("Validate the outputs of the original and exported models."),oo=h(),Me=a("p"),un=n("In this section, we\u2019ll look at how BERT was implemented to show what\u2019s involved with each step."),no=h(),U=a("h2"),ee=a("a"),ht=a("span"),v(ve.$$.fragment),dn=h(),ct=a("span"),mn=n("Implementing a custom ONNX configuration"),so=h(),te=a("p"),gn=n("Let\u2019s start with the ONNX configuration object. We provide a 3-level "),Xe=a("a"),_n=n("class hierarchy"),xn=n(`,
and to add support for a model, inheriting from the right middle-end class will be the way to go most of the time. You might have to
implement a middle-end class yourself if you are adding an architecture handling a modality and/or case never seen before.`),ao=h(),v(oe.$$.fragment),io=h(),Be=a("p"),vn=n(`When inheriting from a middle-end class, look for the one handling the same modality / category of models as the one you
are trying to support.`),ro=h(),H=a("h3"),ne=a("a"),ft=a("span"),v(we.$$.fragment),wn=h(),ut=a("span"),En=n("Example: Adding support for BERT"),lo=h(),X=a("p"),yn=n("Since BERT is an encoder-based model for text, its configuration inherits from the middle-end class "),Fe=a("a"),$n=n("TextEncoderOnnxConfig"),On=n(`.
In `),dt=a("code"),bn=n("optimum/exporters/onnx/model_configs.py"),kn=n(":"),po=h(),v(Ee.$$.fragment),ho=h(),b=a("p"),Nn=n("First let\u2019s explain what "),mt=a("code"),Tn=n("TextEncoderOnnxConfig"),jn=n(" is all about. While most of the features are already implemented in "),gt=a("code"),An=n("OnnxConfig"),Cn=n(`,
this class is modality-agnostic, meaning that it does not know what kind of inputs it should handle. The way input generation is
handled is via the `),_t=a("code"),qn=n("DUMMY_INPUT_GENERATOR_CLASSES"),Dn=n(" attribute, which is a tuple of "),ze=a("a"),Pn=n("DummyInputGenerator"),In=n(`s.
Here we are making a modality-aware configuration inheriting from `),xt=a("code"),Sn=n("OnnxConfig"),Ln=n(` by specifying
`),vt=a("code"),Rn=n("DUMMY_INPUT_GENERATOR_CLASSES = (DummyTextInputGenerator,)"),Mn=n("."),co=h(),se=a("p"),Xn=n("Then comes the model-specific class, "),wt=a("code"),Bn=n("BertOnnxConfig"),Fn=n(". Two class attributes are specified here:"),fo=h(),ae=a("ul"),ie=a("li"),Et=a("code"),zn=n("NORMALIZED_CONFIG_CLASS"),Gn=n(": this must be a "),Ge=a("a"),Un=n("NormalizedConfig"),Hn=n(`, it basically allows
the input generator to access the model config attributes in a generic way.`),Yn=h(),Ue=a("li"),yt=a("code"),Vn=n("ATOL_FOR_VALIDATION"),Wn=n(`: it is used when validating the exported model against the original one, this is the absolute
acceptable tolerance for the output values difference.`),uo=h(),k=a("p"),Zn=n("Every configuration object must implement the "),He=a("a"),Jn=n("inputs"),Kn=n(` property and return a mapping, where each key corresponds to an
input name, and each value indicates the axes in that input that are dynamic.
For BERT, we can see that three inputs are required: `),$t=a("code"),Qn=n("input_ids"),es=n(", "),Ot=a("code"),ts=n("attention_mask"),os=n(" and "),bt=a("code"),ns=n("token_type_ids"),ss=n(`.
These inputs have the same shape of `),kt=a("code"),as=n("(batch_size, sequence_length)"),is=n(" (except for the "),Nt=a("code"),rs=n("multiple-choice"),ls=n(` task) which is
why we see the same axes used in the configuration.`),mo=h(),Ye=a("p"),ps=n("Once you have implemented an ONNX configuration, you can instantiate it by providing the base model\u2019s configuration as follows:"),go=h(),v(ye.$$.fragment),_o=h(),Ve=a("p"),hs=n(`The resulting object has several useful properties. For example, you can view the ONNX
operator set that will be used during the export:`),xo=h(),v($e.$$.fragment),vo=h(),We=a("p"),cs=n("You can also view the outputs associated with the model as follows:"),wo=h(),v(Oe.$$.fragment),Eo=h(),P=a("p"),fs=n(`Notice that the outputs property follows the same structure as the inputs; it returns an
`),Tt=a("code"),us=n("OrderedDict"),ds=n(` of named outputs and their shapes. The output structure is linked to the
choice of task that the configuration is initialised with. By default, the ONNX
configuration is initialized with the `),jt=a("code"),ms=n("default"),gs=n(` task that corresponds to exporting a
model loaded with the `),At=a("code"),_s=n("AutoModel"),xs=n(` class. If you want to export a model for another task,
just provide a different task to the `),Ct=a("code"),vs=n("task"),ws=n(` argument when you initialize the ONNX
configuration. For example, if we wished to export BERT with a sequence
classification head, we could use:`),yo=h(),v(be.$$.fragment),$o=h(),v(re.$$.fragment),Oo=h(),Y=a("h2"),le=a("a"),qt=a("span"),v(ke.$$.fragment),Es=h(),Dt=a("span"),ys=n("Registering the ONNX configuration in the TasksManager"),bo=h(),B=a("p"),$s=n("The "),Ze=a("a"),Os=n("TasksManager"),bs=n(` is the main entry-point to load a model given a name and a task,
and to get the proper configuration for a given (architecture, backend) couple. When adding support for the export to ONNX,
registering the configuration to the `),Pt=a("code"),ks=n("TasksManager"),Ns=n(" will make the export available in the command line tool."),ko=h(),pe=a("p"),Ts=n("To do that, add an entry in the "),It=a("code"),js=n("_SUPPORTED_MODEL_TYPE"),As=n(" attribute:"),No=h(),he=a("ul"),Ne=a("li"),Cs=n(`If the model is already supported for other backends than ONNX, it will already have an entry, so you will only need to
add an `),St=a("code"),qs=n("onnx"),Ds=n(" key specifying the name of the configuration class."),Ps=h(),Lt=a("li"),Is=n("Otherwise, you will have to add the whole entry."),To=h(),Je=a("p"),Ss=n("For BERT, it looks as follows:"),jo=h(),v(Te.$$.fragment),Ao=h(),V=a("h2"),ce=a("a"),Rt=a("span"),v(je.$$.fragment),Ls=h(),Mt=a("span"),Rs=n("Exporting the model"),Co=h(),F=a("p"),Ms=n(`Once you have implemented the ONNX configuration, the next step is to export the model.
Here we can use the `),Xt=a("code"),Xs=n("export()"),Bs=n(" function provided by the "),Bt=a("code"),Fs=n("optimum.exporters.onnx"),zs=n(` package.
This function expects the ONNX configuration, along with the base model, and the path to save the exported file:`),qo=h(),v(Ae.$$.fragment),Do=h(),C=a("p"),Gs=n("The "),Ft=a("code"),Us=n("onnx_inputs"),Hs=n(" and "),zt=a("code"),Ys=n("onnx_outputs"),Vs=n(" returned by the "),Gt=a("code"),Ws=n("export()"),Zs=n(" function are lists of the keys defined in the "),Ke=a("a"),Js=n("inputs"),Ks=n(`
and `),Qe=a("a"),Qs=n("inputs"),ea=n(" properties of the configuration. Once the model is exported, you can test that the model is well formed as follows:"),Po=h(),v(Ce.$$.fragment),Io=h(),v(fe.$$.fragment),So=h(),W=a("h2"),ue=a("a"),Ut=a("span"),v(qe.$$.fragment),ta=h(),Ht=a("span"),oa=n("Validating the model outputs"),Lo=h(),z=a("p"),na=n(`The final step is to validate that the outputs from the base and exported model agree within some absolute tolerance.
Here we can use the `),Yt=a("code"),sa=n("validate_model_outputs()"),aa=n(" function provided by the "),Vt=a("code"),ia=n("optimum.exporters.onnx"),ra=n(" package:"),Ro=h(),v(De.$$.fragment),Mo=h(),Z=a("h2"),de=a("a"),Wt=a("span"),v(Pe.$$.fragment),la=h(),Zt=a("span"),pa=n("Contributing the new configuration to \u{1F917} Optimum"),Xo=h(),et=a("p"),ha=n("Now that the support for the architectures has been implemented, and validated, there are two things left:"),Bo=h(),me=a("ol"),tt=a("li"),ca=n("Add your model architecture to the tests in "),Jt=a("code"),fa=n("tests/exporters/test_onnx_export.py"),ua=h(),ot=a("li"),da=n("Create a PR on the "),ge=a("a"),Kt=a("code"),ma=n("optimum"),ga=n(" repo"),Fo=h(),nt=a("p"),_a=n("Thanks for you contribution!"),this.h()},l(e){const l=zi('[data-svelte="svelte-1phssyn"]',document.head);u=i(l,"META",{name:!0,content:!0}),l.forEach(o),j=c(e),d=i(e,"H1",{class:!0});var Ie=r(d);x=i(Ie,"A",{id:!0,class:!0,href:!0});var Qt=r(x);N=i(Qt,"SPAN",{});var eo=r(N);w(m.$$.fragment,eo),eo.forEach(o),Qt.forEach(o),_=c(Ie),A=i(Ie,"SPAN",{});var $a=r(A);g=s($a,"Adding support for an unsupported architecture"),$a.forEach(o),Ie.forEach(o),T=c(e),L=i(e,"P",{});var Oa=r(L);R=s(Oa,"If you wish to export a model whose architecture is not already supported by the library, these are the main steps to follow:"),Oa.forEach(o),q=c(e),D=i(e,"OL",{});var _e=r(D);Q=i(_e,"LI",{});var ba=r(Q);Le=s(ba,"Implement a custom ONNX configuration."),ba.forEach(o),sn=c(_e),xe=i(_e,"LI",{});var Go=r(xe);an=s(Go,"Register the ONNX configuration in the "),Re=i(Go,"A",{href:!0});var ka=r(Re);rn=s(ka,"TasksManager"),ka.forEach(o),ln=s(Go,"."),Go.forEach(o),pn=c(_e),lt=i(_e,"LI",{});var Na=r(lt);hn=s(Na,"Export the model to ONNX."),Na.forEach(o),cn=c(_e),pt=i(_e,"LI",{});var Ta=r(pt);fn=s(Ta,"Validate the outputs of the original and exported models."),Ta.forEach(o),_e.forEach(o),oo=c(e),Me=i(e,"P",{});var ja=r(Me);un=s(ja,"In this section, we\u2019ll look at how BERT was implemented to show what\u2019s involved with each step."),ja.forEach(o),no=c(e),U=i(e,"H2",{class:!0});var Uo=r(U);ee=i(Uo,"A",{id:!0,class:!0,href:!0});var Aa=r(ee);ht=i(Aa,"SPAN",{});var Ca=r(ht);w(ve.$$.fragment,Ca),Ca.forEach(o),Aa.forEach(o),dn=c(Uo),ct=i(Uo,"SPAN",{});var qa=r(ct);mn=s(qa,"Implementing a custom ONNX configuration"),qa.forEach(o),Uo.forEach(o),so=c(e),te=i(e,"P",{});var Ho=r(te);gn=s(Ho,"Let\u2019s start with the ONNX configuration object. We provide a 3-level "),Xe=i(Ho,"A",{href:!0});var Da=r(Xe);_n=s(Da,"class hierarchy"),Da.forEach(o),xn=s(Ho,`,
and to add support for a model, inheriting from the right middle-end class will be the way to go most of the time. You might have to
implement a middle-end class yourself if you are adding an architecture handling a modality and/or case never seen before.`),Ho.forEach(o),ao=c(e),w(oe.$$.fragment,e),io=c(e),Be=i(e,"P",{});var Pa=r(Be);vn=s(Pa,`When inheriting from a middle-end class, look for the one handling the same modality / category of models as the one you
are trying to support.`),Pa.forEach(o),ro=c(e),H=i(e,"H3",{class:!0});var Yo=r(H);ne=i(Yo,"A",{id:!0,class:!0,href:!0});var Ia=r(ne);ft=i(Ia,"SPAN",{});var Sa=r(ft);w(we.$$.fragment,Sa),Sa.forEach(o),Ia.forEach(o),wn=c(Yo),ut=i(Yo,"SPAN",{});var La=r(ut);En=s(La,"Example: Adding support for BERT"),La.forEach(o),Yo.forEach(o),lo=c(e),X=i(e,"P",{});var st=r(X);yn=s(st,"Since BERT is an encoder-based model for text, its configuration inherits from the middle-end class "),Fe=i(st,"A",{href:!0});var Ra=r(Fe);$n=s(Ra,"TextEncoderOnnxConfig"),Ra.forEach(o),On=s(st,`.
In `),dt=i(st,"CODE",{});var Ma=r(dt);bn=s(Ma,"optimum/exporters/onnx/model_configs.py"),Ma.forEach(o),kn=s(st,":"),st.forEach(o),po=c(e),w(Ee.$$.fragment,e),ho=c(e),b=i(e,"P",{});var I=r(b);Nn=s(I,"First let\u2019s explain what "),mt=i(I,"CODE",{});var Xa=r(mt);Tn=s(Xa,"TextEncoderOnnxConfig"),Xa.forEach(o),jn=s(I," is all about. While most of the features are already implemented in "),gt=i(I,"CODE",{});var Ba=r(gt);An=s(Ba,"OnnxConfig"),Ba.forEach(o),Cn=s(I,`,
this class is modality-agnostic, meaning that it does not know what kind of inputs it should handle. The way input generation is
handled is via the `),_t=i(I,"CODE",{});var Fa=r(_t);qn=s(Fa,"DUMMY_INPUT_GENERATOR_CLASSES"),Fa.forEach(o),Dn=s(I," attribute, which is a tuple of "),ze=i(I,"A",{href:!0});var za=r(ze);Pn=s(za,"DummyInputGenerator"),za.forEach(o),In=s(I,`s.
Here we are making a modality-aware configuration inheriting from `),xt=i(I,"CODE",{});var Ga=r(xt);Sn=s(Ga,"OnnxConfig"),Ga.forEach(o),Ln=s(I,` by specifying
`),vt=i(I,"CODE",{});var Ua=r(vt);Rn=s(Ua,"DUMMY_INPUT_GENERATOR_CLASSES = (DummyTextInputGenerator,)"),Ua.forEach(o),Mn=s(I,"."),I.forEach(o),co=c(e),se=i(e,"P",{});var Vo=r(se);Xn=s(Vo,"Then comes the model-specific class, "),wt=i(Vo,"CODE",{});var Ha=r(wt);Bn=s(Ha,"BertOnnxConfig"),Ha.forEach(o),Fn=s(Vo,". Two class attributes are specified here:"),Vo.forEach(o),fo=c(e),ae=i(e,"UL",{});var Wo=r(ae);ie=i(Wo,"LI",{});var to=r(ie);Et=i(to,"CODE",{});var Ya=r(Et);zn=s(Ya,"NORMALIZED_CONFIG_CLASS"),Ya.forEach(o),Gn=s(to,": this must be a "),Ge=i(to,"A",{href:!0});var Va=r(Ge);Un=s(Va,"NormalizedConfig"),Va.forEach(o),Hn=s(to,`, it basically allows
the input generator to access the model config attributes in a generic way.`),to.forEach(o),Yn=c(Wo),Ue=i(Wo,"LI",{});var xa=r(Ue);yt=i(xa,"CODE",{});var Wa=r(yt);Vn=s(Wa,"ATOL_FOR_VALIDATION"),Wa.forEach(o),Wn=s(xa,`: it is used when validating the exported model against the original one, this is the absolute
acceptable tolerance for the output values difference.`),xa.forEach(o),Wo.forEach(o),uo=c(e),k=i(e,"P",{});var S=r(k);Zn=s(S,"Every configuration object must implement the "),He=i(S,"A",{href:!0});var Za=r(He);Jn=s(Za,"inputs"),Za.forEach(o),Kn=s(S,` property and return a mapping, where each key corresponds to an
input name, and each value indicates the axes in that input that are dynamic.
For BERT, we can see that three inputs are required: `),$t=i(S,"CODE",{});var Ja=r($t);Qn=s(Ja,"input_ids"),Ja.forEach(o),es=s(S,", "),Ot=i(S,"CODE",{});var Ka=r(Ot);ts=s(Ka,"attention_mask"),Ka.forEach(o),os=s(S," and "),bt=i(S,"CODE",{});var Qa=r(bt);ns=s(Qa,"token_type_ids"),Qa.forEach(o),ss=s(S,`.
These inputs have the same shape of `),kt=i(S,"CODE",{});var ei=r(kt);as=s(ei,"(batch_size, sequence_length)"),ei.forEach(o),is=s(S," (except for the "),Nt=i(S,"CODE",{});var ti=r(Nt);rs=s(ti,"multiple-choice"),ti.forEach(o),ls=s(S,` task) which is
why we see the same axes used in the configuration.`),S.forEach(o),mo=c(e),Ye=i(e,"P",{});var oi=r(Ye);ps=s(oi,"Once you have implemented an ONNX configuration, you can instantiate it by providing the base model\u2019s configuration as follows:"),oi.forEach(o),go=c(e),w(ye.$$.fragment,e),_o=c(e),Ve=i(e,"P",{});var ni=r(Ve);hs=s(ni,`The resulting object has several useful properties. For example, you can view the ONNX
operator set that will be used during the export:`),ni.forEach(o),xo=c(e),w($e.$$.fragment,e),vo=c(e),We=i(e,"P",{});var si=r(We);cs=s(si,"You can also view the outputs associated with the model as follows:"),si.forEach(o),wo=c(e),w(Oe.$$.fragment,e),Eo=c(e),P=i(e,"P",{});var G=r(P);fs=s(G,`Notice that the outputs property follows the same structure as the inputs; it returns an
`),Tt=i(G,"CODE",{});var ai=r(Tt);us=s(ai,"OrderedDict"),ai.forEach(o),ds=s(G,` of named outputs and their shapes. The output structure is linked to the
choice of task that the configuration is initialised with. By default, the ONNX
configuration is initialized with the `),jt=i(G,"CODE",{});var ii=r(jt);ms=s(ii,"default"),ii.forEach(o),gs=s(G,` task that corresponds to exporting a
model loaded with the `),At=i(G,"CODE",{});var ri=r(At);_s=s(ri,"AutoModel"),ri.forEach(o),xs=s(G,` class. If you want to export a model for another task,
just provide a different task to the `),Ct=i(G,"CODE",{});var li=r(Ct);vs=s(li,"task"),li.forEach(o),ws=s(G,` argument when you initialize the ONNX
configuration. For example, if we wished to export BERT with a sequence
classification head, we could use:`),G.forEach(o),yo=c(e),w(be.$$.fragment,e),$o=c(e),w(re.$$.fragment,e),Oo=c(e),Y=i(e,"H2",{class:!0});var Zo=r(Y);le=i(Zo,"A",{id:!0,class:!0,href:!0});var pi=r(le);qt=i(pi,"SPAN",{});var hi=r(qt);w(ke.$$.fragment,hi),hi.forEach(o),pi.forEach(o),Es=c(Zo),Dt=i(Zo,"SPAN",{});var ci=r(Dt);ys=s(ci,"Registering the ONNX configuration in the TasksManager"),ci.forEach(o),Zo.forEach(o),bo=c(e),B=i(e,"P",{});var at=r(B);$s=s(at,"The "),Ze=i(at,"A",{href:!0});var fi=r(Ze);Os=s(fi,"TasksManager"),fi.forEach(o),bs=s(at,` is the main entry-point to load a model given a name and a task,
and to get the proper configuration for a given (architecture, backend) couple. When adding support for the export to ONNX,
registering the configuration to the `),Pt=i(at,"CODE",{});var ui=r(Pt);ks=s(ui,"TasksManager"),ui.forEach(o),Ns=s(at," will make the export available in the command line tool."),at.forEach(o),ko=c(e),pe=i(e,"P",{});var Jo=r(pe);Ts=s(Jo,"To do that, add an entry in the "),It=i(Jo,"CODE",{});var di=r(It);js=s(di,"_SUPPORTED_MODEL_TYPE"),di.forEach(o),As=s(Jo," attribute:"),Jo.forEach(o),No=c(e),he=i(e,"UL",{});var Ko=r(he);Ne=i(Ko,"LI",{});var Qo=r(Ne);Cs=s(Qo,`If the model is already supported for other backends than ONNX, it will already have an entry, so you will only need to
add an `),St=i(Qo,"CODE",{});var mi=r(St);qs=s(mi,"onnx"),mi.forEach(o),Ds=s(Qo," key specifying the name of the configuration class."),Qo.forEach(o),Ps=c(Ko),Lt=i(Ko,"LI",{});var gi=r(Lt);Is=s(gi,"Otherwise, you will have to add the whole entry."),gi.forEach(o),Ko.forEach(o),To=c(e),Je=i(e,"P",{});var _i=r(Je);Ss=s(_i,"For BERT, it looks as follows:"),_i.forEach(o),jo=c(e),w(Te.$$.fragment,e),Ao=c(e),V=i(e,"H2",{class:!0});var en=r(V);ce=i(en,"A",{id:!0,class:!0,href:!0});var xi=r(ce);Rt=i(xi,"SPAN",{});var vi=r(Rt);w(je.$$.fragment,vi),vi.forEach(o),xi.forEach(o),Ls=c(en),Mt=i(en,"SPAN",{});var wi=r(Mt);Rs=s(wi,"Exporting the model"),wi.forEach(o),en.forEach(o),Co=c(e),F=i(e,"P",{});var it=r(F);Ms=s(it,`Once you have implemented the ONNX configuration, the next step is to export the model.
Here we can use the `),Xt=i(it,"CODE",{});var Ei=r(Xt);Xs=s(Ei,"export()"),Ei.forEach(o),Bs=s(it," function provided by the "),Bt=i(it,"CODE",{});var yi=r(Bt);Fs=s(yi,"optimum.exporters.onnx"),yi.forEach(o),zs=s(it,` package.
This function expects the ONNX configuration, along with the base model, and the path to save the exported file:`),it.forEach(o),qo=c(e),w(Ae.$$.fragment,e),Do=c(e),C=i(e,"P",{});var M=r(C);Gs=s(M,"The "),Ft=i(M,"CODE",{});var $i=r(Ft);Us=s($i,"onnx_inputs"),$i.forEach(o),Hs=s(M," and "),zt=i(M,"CODE",{});var Oi=r(zt);Ys=s(Oi,"onnx_outputs"),Oi.forEach(o),Vs=s(M," returned by the "),Gt=i(M,"CODE",{});var bi=r(Gt);Ws=s(bi,"export()"),bi.forEach(o),Zs=s(M," function are lists of the keys defined in the "),Ke=i(M,"A",{href:!0});var ki=r(Ke);Js=s(ki,"inputs"),ki.forEach(o),Ks=s(M,`
and `),Qe=i(M,"A",{href:!0});var Ni=r(Qe);Qs=s(Ni,"inputs"),Ni.forEach(o),ea=s(M," properties of the configuration. Once the model is exported, you can test that the model is well formed as follows:"),M.forEach(o),Po=c(e),w(Ce.$$.fragment,e),Io=c(e),w(fe.$$.fragment,e),So=c(e),W=i(e,"H2",{class:!0});var tn=r(W);ue=i(tn,"A",{id:!0,class:!0,href:!0});var Ti=r(ue);Ut=i(Ti,"SPAN",{});var ji=r(Ut);w(qe.$$.fragment,ji),ji.forEach(o),Ti.forEach(o),ta=c(tn),Ht=i(tn,"SPAN",{});var Ai=r(Ht);oa=s(Ai,"Validating the model outputs"),Ai.forEach(o),tn.forEach(o),Lo=c(e),z=i(e,"P",{});var rt=r(z);na=s(rt,`The final step is to validate that the outputs from the base and exported model agree within some absolute tolerance.
Here we can use the `),Yt=i(rt,"CODE",{});var Ci=r(Yt);sa=s(Ci,"validate_model_outputs()"),Ci.forEach(o),aa=s(rt," function provided by the "),Vt=i(rt,"CODE",{});var qi=r(Vt);ia=s(qi,"optimum.exporters.onnx"),qi.forEach(o),ra=s(rt," package:"),rt.forEach(o),Ro=c(e),w(De.$$.fragment,e),Mo=c(e),Z=i(e,"H2",{class:!0});var on=r(Z);de=i(on,"A",{id:!0,class:!0,href:!0});var Di=r(de);Wt=i(Di,"SPAN",{});var Pi=r(Wt);w(Pe.$$.fragment,Pi),Pi.forEach(o),Di.forEach(o),la=c(on),Zt=i(on,"SPAN",{});var Ii=r(Zt);pa=s(Ii,"Contributing the new configuration to \u{1F917} Optimum"),Ii.forEach(o),on.forEach(o),Xo=c(e),et=i(e,"P",{});var Si=r(et);ha=s(Si,"Now that the support for the architectures has been implemented, and validated, there are two things left:"),Si.forEach(o),Bo=c(e),me=i(e,"OL",{});var nn=r(me);tt=i(nn,"LI",{});var va=r(tt);ca=s(va,"Add your model architecture to the tests in "),Jt=i(va,"CODE",{});var Li=r(Jt);fa=s(Li,"tests/exporters/test_onnx_export.py"),Li.forEach(o),va.forEach(o),ua=c(nn),ot=i(nn,"LI",{});var wa=r(ot);da=s(wa,"Create a PR on the "),ge=i(wa,"A",{href:!0,rel:!0});var Ea=r(ge);Kt=i(Ea,"CODE",{});var Ri=r(Kt);ma=s(Ri,"optimum"),Ri.forEach(o),ga=s(Ea," repo"),Ea.forEach(o),wa.forEach(o),nn.forEach(o),Fo=c(e),nt=i(e,"P",{});var Mi=r(nt);_a=s(Mi,"Thanks for you contribution!"),Mi.forEach(o),this.h()},h(){f(u,"name","hf:doc:metadata"),f(u,"content",JSON.stringify(Wi)),f(x,"id","adding-support-for-an-unsupported-architecture"),f(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(x,"href","#adding-support-for-an-unsupported-architecture"),f(d,"class","relative group"),f(Re,"href","/docs/optimum/main/en/exporters/task_manager#optimum.exporters.TasksManager"),f(ee,"id","implementing-a-custom-onnx-configuration"),f(ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(ee,"href","#implementing-a-custom-onnx-configuration"),f(U,"class","relative group"),f(Xe,"href","/exporters/onnx/package_reference/configuration"),f(ne,"id","example-adding-support-for-bert"),f(ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(ne,"href","#example-adding-support-for-bert"),f(H,"class","relative group"),f(Fe,"href","/docs/optimum/main/en/exporters/onnx/package_reference/configuration#optimum.exporters.onnx.TextEncoderOnnxConfig"),f(ze,"href","/docs/optimum/main/en/utils/dummy_input_generators#optimum.utils.DummyInputGenerator"),f(Ge,"href","/docs/optimum/main/en/utils/normalized_config#optimum.utils.NormalizedConfig"),f(He,"href","/docs/optimum/main/en/exporters/onnx/package_reference/configuration#optimum.exporters.onnx.OnnxConfig.inputs"),f(le,"id","registering-the-onnx-configuration-in-the-tasksmanager"),f(le,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(le,"href","#registering-the-onnx-configuration-in-the-tasksmanager"),f(Y,"class","relative group"),f(Ze,"href","/docs/optimum/main/en/exporters/task_manager#optimum.exporters.TasksManager"),f(ce,"id","exporting-the-model"),f(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(ce,"href","#exporting-the-model"),f(V,"class","relative group"),f(Ke,"href","/docs/optimum/main/en/exporters/onnx/package_reference/configuration#optimum.exporters.onnx.OnnxConfig.inputs"),f(Qe,"href","/docs/optimum/main/en/exporters/onnx/package_reference/configuration#optimum.exporters.onnx.OnnxConfig.inputs"),f(ue,"id","validating-the-model-outputs"),f(ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(ue,"href","#validating-the-model-outputs"),f(W,"class","relative group"),f(de,"id","contributing-the-new-configuration-to-optimum"),f(de,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(de,"href","#contributing-the-new-configuration-to-optimum"),f(Z,"class","relative group"),f(ge,"href","https://github.com/huggingface/optimum"),f(ge,"rel","nofollow")},m(e,l){t(document.head,u),p(e,j,l),p(e,d,l),t(d,x),t(x,N),E(m,N,null),t(d,_),t(d,A),t(A,g),p(e,T,l),p(e,L,l),t(L,R),p(e,q,l),p(e,D,l),t(D,Q),t(Q,Le),t(D,sn),t(D,xe),t(xe,an),t(xe,Re),t(Re,rn),t(xe,ln),t(D,pn),t(D,lt),t(lt,hn),t(D,cn),t(D,pt),t(pt,fn),p(e,oo,l),p(e,Me,l),t(Me,un),p(e,no,l),p(e,U,l),t(U,ee),t(ee,ht),E(ve,ht,null),t(U,dn),t(U,ct),t(ct,mn),p(e,so,l),p(e,te,l),t(te,gn),t(te,Xe),t(Xe,_n),t(te,xn),p(e,ao,l),E(oe,e,l),p(e,io,l),p(e,Be,l),t(Be,vn),p(e,ro,l),p(e,H,l),t(H,ne),t(ne,ft),E(we,ft,null),t(H,wn),t(H,ut),t(ut,En),p(e,lo,l),p(e,X,l),t(X,yn),t(X,Fe),t(Fe,$n),t(X,On),t(X,dt),t(dt,bn),t(X,kn),p(e,po,l),E(Ee,e,l),p(e,ho,l),p(e,b,l),t(b,Nn),t(b,mt),t(mt,Tn),t(b,jn),t(b,gt),t(gt,An),t(b,Cn),t(b,_t),t(_t,qn),t(b,Dn),t(b,ze),t(ze,Pn),t(b,In),t(b,xt),t(xt,Sn),t(b,Ln),t(b,vt),t(vt,Rn),t(b,Mn),p(e,co,l),p(e,se,l),t(se,Xn),t(se,wt),t(wt,Bn),t(se,Fn),p(e,fo,l),p(e,ae,l),t(ae,ie),t(ie,Et),t(Et,zn),t(ie,Gn),t(ie,Ge),t(Ge,Un),t(ie,Hn),t(ae,Yn),t(ae,Ue),t(Ue,yt),t(yt,Vn),t(Ue,Wn),p(e,uo,l),p(e,k,l),t(k,Zn),t(k,He),t(He,Jn),t(k,Kn),t(k,$t),t($t,Qn),t(k,es),t(k,Ot),t(Ot,ts),t(k,os),t(k,bt),t(bt,ns),t(k,ss),t(k,kt),t(kt,as),t(k,is),t(k,Nt),t(Nt,rs),t(k,ls),p(e,mo,l),p(e,Ye,l),t(Ye,ps),p(e,go,l),E(ye,e,l),p(e,_o,l),p(e,Ve,l),t(Ve,hs),p(e,xo,l),E($e,e,l),p(e,vo,l),p(e,We,l),t(We,cs),p(e,wo,l),E(Oe,e,l),p(e,Eo,l),p(e,P,l),t(P,fs),t(P,Tt),t(Tt,us),t(P,ds),t(P,jt),t(jt,ms),t(P,gs),t(P,At),t(At,_s),t(P,xs),t(P,Ct),t(Ct,vs),t(P,ws),p(e,yo,l),E(be,e,l),p(e,$o,l),E(re,e,l),p(e,Oo,l),p(e,Y,l),t(Y,le),t(le,qt),E(ke,qt,null),t(Y,Es),t(Y,Dt),t(Dt,ys),p(e,bo,l),p(e,B,l),t(B,$s),t(B,Ze),t(Ze,Os),t(B,bs),t(B,Pt),t(Pt,ks),t(B,Ns),p(e,ko,l),p(e,pe,l),t(pe,Ts),t(pe,It),t(It,js),t(pe,As),p(e,No,l),p(e,he,l),t(he,Ne),t(Ne,Cs),t(Ne,St),t(St,qs),t(Ne,Ds),t(he,Ps),t(he,Lt),t(Lt,Is),p(e,To,l),p(e,Je,l),t(Je,Ss),p(e,jo,l),E(Te,e,l),p(e,Ao,l),p(e,V,l),t(V,ce),t(ce,Rt),E(je,Rt,null),t(V,Ls),t(V,Mt),t(Mt,Rs),p(e,Co,l),p(e,F,l),t(F,Ms),t(F,Xt),t(Xt,Xs),t(F,Bs),t(F,Bt),t(Bt,Fs),t(F,zs),p(e,qo,l),E(Ae,e,l),p(e,Do,l),p(e,C,l),t(C,Gs),t(C,Ft),t(Ft,Us),t(C,Hs),t(C,zt),t(zt,Ys),t(C,Vs),t(C,Gt),t(Gt,Ws),t(C,Zs),t(C,Ke),t(Ke,Js),t(C,Ks),t(C,Qe),t(Qe,Qs),t(C,ea),p(e,Po,l),E(Ce,e,l),p(e,Io,l),E(fe,e,l),p(e,So,l),p(e,W,l),t(W,ue),t(ue,Ut),E(qe,Ut,null),t(W,ta),t(W,Ht),t(Ht,oa),p(e,Lo,l),p(e,z,l),t(z,na),t(z,Yt),t(Yt,sa),t(z,aa),t(z,Vt),t(Vt,ia),t(z,ra),p(e,Ro,l),E(De,e,l),p(e,Mo,l),p(e,Z,l),t(Z,de),t(de,Wt),E(Pe,Wt,null),t(Z,la),t(Z,Zt),t(Zt,pa),p(e,Xo,l),p(e,et,l),t(et,ha),p(e,Bo,l),p(e,me,l),t(me,tt),t(tt,ca),t(tt,Jt),t(Jt,fa),t(me,ua),t(me,ot),t(ot,da),t(ot,ge),t(ge,Kt),t(Kt,ma),t(ge,ga),p(e,Fo,l),p(e,nt,l),t(nt,_a),zo=!0},p(e,[l]){const Ie={};l&2&&(Ie.$$scope={dirty:l,ctx:e}),oe.$set(Ie);const Qt={};l&2&&(Qt.$$scope={dirty:l,ctx:e}),re.$set(Qt);const eo={};l&2&&(eo.$$scope={dirty:l,ctx:e}),fe.$set(eo)},i(e){zo||(y(m.$$.fragment,e),y(ve.$$.fragment,e),y(oe.$$.fragment,e),y(we.$$.fragment,e),y(Ee.$$.fragment,e),y(ye.$$.fragment,e),y($e.$$.fragment,e),y(Oe.$$.fragment,e),y(be.$$.fragment,e),y(re.$$.fragment,e),y(ke.$$.fragment,e),y(Te.$$.fragment,e),y(je.$$.fragment,e),y(Ae.$$.fragment,e),y(Ce.$$.fragment,e),y(fe.$$.fragment,e),y(qe.$$.fragment,e),y(De.$$.fragment,e),y(Pe.$$.fragment,e),zo=!0)},o(e){$(m.$$.fragment,e),$(ve.$$.fragment,e),$(oe.$$.fragment,e),$(we.$$.fragment,e),$(Ee.$$.fragment,e),$(ye.$$.fragment,e),$($e.$$.fragment,e),$(Oe.$$.fragment,e),$(be.$$.fragment,e),$(re.$$.fragment,e),$(ke.$$.fragment,e),$(Te.$$.fragment,e),$(je.$$.fragment,e),$(Ae.$$.fragment,e),$(Ce.$$.fragment,e),$(fe.$$.fragment,e),$(qe.$$.fragment,e),$(De.$$.fragment,e),$(Pe.$$.fragment,e),zo=!1},d(e){o(u),e&&o(j),e&&o(d),O(m),e&&o(T),e&&o(L),e&&o(q),e&&o(D),e&&o(oo),e&&o(Me),e&&o(no),e&&o(U),O(ve),e&&o(so),e&&o(te),e&&o(ao),O(oe,e),e&&o(io),e&&o(Be),e&&o(ro),e&&o(H),O(we),e&&o(lo),e&&o(X),e&&o(po),O(Ee,e),e&&o(ho),e&&o(b),e&&o(co),e&&o(se),e&&o(fo),e&&o(ae),e&&o(uo),e&&o(k),e&&o(mo),e&&o(Ye),e&&o(go),O(ye,e),e&&o(_o),e&&o(Ve),e&&o(xo),O($e,e),e&&o(vo),e&&o(We),e&&o(wo),O(Oe,e),e&&o(Eo),e&&o(P),e&&o(yo),O(be,e),e&&o($o),O(re,e),e&&o(Oo),e&&o(Y),O(ke),e&&o(bo),e&&o(B),e&&o(ko),e&&o(pe),e&&o(No),e&&o(he),e&&o(To),e&&o(Je),e&&o(jo),O(Te,e),e&&o(Ao),e&&o(V),O(je),e&&o(Co),e&&o(F),e&&o(qo),O(Ae,e),e&&o(Do),e&&o(C),e&&o(Po),O(Ce,e),e&&o(Io),O(fe,e),e&&o(So),e&&o(W),O(qe),e&&o(Lo),e&&o(z),e&&o(Ro),O(De,e),e&&o(Mo),e&&o(Z),O(Pe),e&&o(Xo),e&&o(et),e&&o(Bo),e&&o(me),e&&o(Fo),e&&o(nt)}}}const Wi={local:"adding-support-for-an-unsupported-architecture",sections:[{local:"implementing-a-custom-onnx-configuration",sections:[{local:"example-adding-support-for-bert",title:"Example: Adding support for BERT"}],title:"Implementing a custom ONNX configuration"},{local:"registering-the-onnx-configuration-in-the-tasksmanager",title:"Registering the ONNX configuration in the TasksManager"},{local:"exporting-the-model",title:"Exporting the model"},{local:"validating-the-model-outputs",title:"Validating the model outputs"},{local:"contributing-the-new-configuration-to-optimum",title:"Contributing the new configuration to \u{1F917} Optimum"}],title:"Adding support for an unsupported architecture"};function Zi(K){return Gi(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class tr extends Xi{constructor(u){super();Bi(this,u,Zi,Vi,Fi,{})}}export{tr as default,Wi as metadata};
