import{S as fs,i as cs,s as gs,e as l,k as m,w as x,t as a,M as _s,c as i,d as t,m as d,a as p,x as $,h as n,b as h,G as o,g as r,y as N,q as v,o as b,B as O,v as ws,L as ks}from"../../../../chunks/vendor-hf-doc-builder.js";import{T as hs}from"../../../../chunks/Tip-hf-doc-builder.js";import{I as jo}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{C as z}from"../../../../chunks/CodeBlock-hf-doc-builder.js";function xs(xe){let u,X,c,w,q;return{c(){u=l("p"),X=a(`Once exported, a model can be optimized for inference via techniques such as
graph optimization and quantization. Check the `),c=l("code"),w=a("optimum.onnxruntime"),q=a(" subpackage to optimize and run ONNX models!")},l(g){u=i(g,"P",{});var _=p(u);X=n(_,`Once exported, a model can be optimized for inference via techniques such as
graph optimization and quantization. Check the `),c=i(_,"CODE",{});var A=p(c);w=n(A,"optimum.onnxruntime"),A.forEach(t),q=n(_," subpackage to optimize and run ONNX models!"),_.forEach(t)},m(g,_){r(g,u,_),o(u,X),o(u,c),o(c,w),o(u,q)},d(g){g&&t(u)}}}function $s(xe){let u,X,c,w,q,g,_,A,E,H,y,te,j,F,oe,K,P;return _=new z({props:{code:'model = ORTModelForQuestionAnswering.from_pretrained("distilbert-base-uncased-distilled-squad", from_transformers=True)',highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>model = ORTModelForQuestionAnswering.from_pretrained(<span class="hljs-string">&quot;distilbert-base-uncased-distilled-squad&quot;</span>, from_transformers=<span class="hljs-literal">True</span>)'}}),{c(){u=l("p"),X=a("It is also possible to export the model to ONNX directly from the "),c=l("code"),w=a("ORTModelForQuestionAnswering"),q=a(" class by doing the following:"),g=m(),x(_.$$.fragment),A=m(),E=l("p"),H=a("For more information, check the "),y=l("code"),te=a("optimum.onnxrutime"),j=a(" documentation "),F=l("a"),oe=a("page on this topic"),K=a("."),this.h()},l(f){u=i(f,"P",{});var k=p(u);X=n(k,"It is also possible to export the model to ONNX directly from the "),c=i(k,"CODE",{});var $e=p(c);w=n($e,"ORTModelForQuestionAnswering"),$e.forEach(t),q=n(k," class by doing the following:"),k.forEach(t),g=d(f),$(_.$$.fragment,f),A=d(f),E=i(f,"P",{});var D=p(E);H=n(D,"For more information, check the "),y=i(D,"CODE",{});var se=p(y);te=n(se,"optimum.onnxrutime"),se.forEach(t),j=n(D," documentation "),F=i(D,"A",{href:!0});var R=p(F);oe=n(R,"page on this topic"),R.forEach(t),K=n(D,"."),D.forEach(t),this.h()},h(){h(F,"href","/onnxruntime/overview")},m(f,k){r(f,u,k),o(u,X),o(u,c),o(c,w),o(u,q),r(f,g,k),N(_,f,k),r(f,A,k),r(f,E,k),o(E,H),o(E,y),o(y,te),o(E,j),o(E,F),o(F,oe),o(E,K),P=!0},p:ks,i(f){P||(v(_.$$.fragment,f),P=!0)},o(f){b(_.$$.fragment,f),P=!1},d(f){f&&t(u),f&&t(g),O(_,f),f&&t(A),f&&t(E)}}}function Ns(xe){let u,X,c,w,q,g,_,A,E,H,y,te,j,F,oe,K,P,f,k,$e,D,se,R,Dt,Ye,Q,Ue,Ne,Mt,We,ve,ae,It,be,Ct,zt,Ge,S,B,Fe,ne,Rt,De,St,Je,Oe,Lt,Ze,re,et,V,Ht,Me,Kt,Qt,tt,le,ot,Ee,Bt,st,ie,at,ye,Vt,nt,pe,rt,Y,Yt,Ie,Ut,Wt,lt,U,Gt,Ce,Jt,Zt,it,me,pt,W,eo,ze,to,oo,mt,T,so,Re,ao,no,de,ro,lo,ue,io,po,Se,mo,uo,dt,he,ut,Te,ho,ht,fe,ft,qe,fo,ct,G,gt,J,co,ce,go,_o,_t,ge,wt,L,Z,Le,_e,wo,He,ko,kt,M,xo,Ke,$o,No,Ae,vo,bo,xt,ee,Oo,Pe,Eo,yo,$t,we,Nt,I,To,Qe,qo,Ao,Be,Po,Xo,vt;return g=new jo({}),Q=new hs({props:{$$slots:{default:[xs]},$$scope:{ctx:xe}}}),ne=new jo({}),re=new z({props:{code:"pip install optimum[exporters]",highlighted:"pip install optimum[exporters]"}}),le=new z({props:{code:`python -m optimum.exporters.onnx --help

usage: Hugging Face Optimum ONNX exporter [-h] -m MODEL [--task TASK] [--opset OPSET] [--atol ATOL] [--framework {pt,tf}] [--pad_token_id PAD_TOKEN_ID] [--cache_dir CACHE_DIR] output

positional arguments:
  output                Path indicating the directory where to store generated ONNX model.

optional arguments:
  -h, --help            show this help message and exit
  -m MODEL, --model MODEL
                        Model ID on huggingface.co or path on disk to load model from.
  --task TASK           The type of task to export the model with.
  --opset OPSET         ONNX opset version to export the model with.
  --atol ATOL           Absolute difference tolerance when validating the model.
  --framework {pt,tf}   The framework to use for the ONNX export. If not provided, will attempt to use the local checkpoint's original framework or what is available in the environment.
  --pad_token_id PAD_TOKEN_ID
                        This is needed by some models, for some tasks. If not provided, will attempt to use the tokenizer to guess it.
  --cache_dir CACHE_DIR
                        Path indicating where to store cache.`,highlighted:`python -m optimum.exporters.onnx --<span class="hljs-built_in">help</span>

usage: Hugging Face Optimum ONNX exporter [-h] -m MODEL [--task TASK] [--opset OPSET] [--atol ATOL] [--framework {pt,tf}] [--pad_token_id PAD_TOKEN_ID] [--cache_dir CACHE_DIR] output

positional arguments:
  output                Path indicating the directory <span class="hljs-built_in">where</span> to store generated ONNX model.

optional arguments:
  -h, --<span class="hljs-built_in">help</span>            show this <span class="hljs-built_in">help</span> message and <span class="hljs-built_in">exit</span>
  -m MODEL, --model MODEL
                        Model ID on huggingface.co or path on disk to load model from.
  --task TASK           The <span class="hljs-built_in">type</span> of task to <span class="hljs-built_in">export</span> the model with.
  --opset OPSET         ONNX opset version to <span class="hljs-built_in">export</span> the model with.
  --atol ATOL           Absolute difference tolerance when validating the model.
  --framework {pt,tf}   The framework to use <span class="hljs-keyword">for</span> the ONNX <span class="hljs-built_in">export</span>. If not provided, will attempt to use the <span class="hljs-built_in">local</span> checkpoint<span class="hljs-string">&#x27;s original framework or what is available in the environment.
  --pad_token_id PAD_TOKEN_ID
                        This is needed by some models, for some tasks. If not provided, will attempt to use the tokenizer to guess it.
  --cache_dir CACHE_DIR
                        Path indicating where to store cache.</span>`}}),ie=new z({props:{code:"python -m optimum.exporters.onnx --model distilbert-base-uncased-distilled-squad distilbert_base_uncased_squad_onnx/",highlighted:"python -m optimum.exporters.onnx --model distilbert-base-uncased-distilled-squad distilbert_base_uncased_squad_onnx/"}}),pe=new z({props:{code:`Automatic task detection to question-answering.
Framework not specified. Using pt to export to ONNX.
Using framework PyTorch: 1.12.1

Validating ONNX model...
        -[\u2713] ONNX model output names match reference model (start_logits, end_logits)
        - Validating ONNX Model output "start_logits":
                -[\u2713] (2, 16) matches (2, 16)
                -[\u2713] all values close (atol: 0.0001)
        - Validating ONNX Model output "end_logits":
                -[\u2713] (2, 16) matches (2, 16)
                -[\u2713] all values close (atol: 0.0001)
All good, model saved at: distilbert_base_uncased_squad_onnx/model.onnx`,highlighted:`Automatic task detection to question-answering.
Framework not specified. Using pt to <span class="hljs-built_in">export</span> to ONNX.
Using framework PyTorch: 1.12.1

Validating ONNX model...
        -[\u2713] ONNX model output names match reference model (start_logits, end_logits)
        - Validating ONNX Model output <span class="hljs-string">&quot;start_logits&quot;</span>:
                -[\u2713] (2, 16) matches (2, 16)
                -[\u2713] all values close (atol: 0.0001)
        - Validating ONNX Model output <span class="hljs-string">&quot;end_logits&quot;</span>:
                -[\u2713] (2, 16) matches (2, 16)
                -[\u2713] all values close (atol: 0.0001)
All good, model saved at: distilbert_base_uncased_squad_onnx/model.onnx`}}),me=new z({props:{code:"python -m optimum.exporters.onnx --model local_path --task question-answering distilbert_base_uncased_squad_onnx/",highlighted:"python -m optimum.exporters.onnx --model local_path --task question-answering distilbert_base_uncased_squad_onnx/"}}),he=new z({props:{code:`from transformers import AutoTokenizer
from optimum.onnxruntime import ORTModelForQuestionAnswering

tokenizer = AutoTokenizer.from_pretrained("distilbert_base_uncased_squad_onnx")
model = ORTModelForQuestionAnswering.from_pretrained("distilbert_base_uncased_squad_onnx")

inputs = tokenizer("What am I using?", "Using DistilBERT with ONNX Runtime!", return_tensors="pt")
outputs = model(**inputs)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTModelForQuestionAnswering

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;distilbert_base_uncased_squad_onnx&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = ORTModelForQuestionAnswering.from_pretrained(<span class="hljs-string">&quot;distilbert_base_uncased_squad_onnx&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;What am I using?&quot;</span>, <span class="hljs-string">&quot;Using DistilBERT with ONNX Runtime!&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)`}}),fe=new z({props:{code:`QuestionAnsweringModelOutput(loss=None, start_logits=tensor([[-4.7652, -1.0452, -7.0409, -4.6864, -4.0277, -6.2021, -4.9473,  2.6287,
          7.6111, -1.2488, -2.0551, -0.9350,  4.9758, -0.7707,  2.1493, -2.0703,
         -4.3232, -4.9472]]), end_logits=tensor([[ 0.4382, -1.6502, -6.3654, -6.0661, -4.1482, -3.5779, -0.0774, -3.6168,
         -1.8750, -2.8910,  6.2582,  0.5425, -3.7699,  3.8232, -1.5073,  6.2311,
          3.3604, -0.0772]]), hidden_states=None, attentions=None)`,highlighted:`QuestionAnsweringModelOutput(loss=None, start_logits=tensor([[-4.7652, -1.0452, -7.0409, -4.6864, -4.0277, -6.2021, -4.9473,  2.6287,
          7.6111, -1.2488, -2.0551, -0.9350,  4.9758, -0.7707,  2.1493, -2.0703,
         -4.3232, -4.9472]]), end_logits=tensor([[ 0.4382, -1.6502, -6.3654, -6.0661, -4.1482, -3.5779, -0.0774, -3.6168,
         -1.8750, -2.8910,  6.2582,  0.5425, -3.7699,  3.8232, -1.5073,  6.2311,
          3.3604, -0.0772]]), hidden_states=None, attentions=None)`}}),G=new hs({props:{$$slots:{default:[$s]},$$scope:{ctx:xe}}}),ge=new z({props:{code:"python -m optimum.exporters.onnx --model keras-io/transformers-qa distilbert_base_cased_squad_onnx/",highlighted:"python -m optimum.exporters.onnx --model keras-io/transformers-qa distilbert_base_cased_squad_onnx/"}}),_e=new jo({}),we=new z({props:{code:`from optimum.exporters.tasks import TasksManager

distilbert_tasks = list(TasksManager.get_supported_tasks_for_model_type("distilbert", "onnx").keys())
print(distilbert_tasks)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.exporters.tasks <span class="hljs-keyword">import</span> TasksManager

<span class="hljs-meta">&gt;&gt;&gt; </span>distilbert_tasks = <span class="hljs-built_in">list</span>(TasksManager.get_supported_tasks_for_model_type(<span class="hljs-string">&quot;distilbert&quot;</span>, <span class="hljs-string">&quot;onnx&quot;</span>).keys())
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(distilbert_tasks)
[<span class="hljs-string">&quot;default&quot;</span>, <span class="hljs-string">&quot;masked-lm&quot;</span>, <span class="hljs-string">&quot;causal-lm&quot;</span>, <span class="hljs-string">&quot;sequence-classification&quot;</span>, <span class="hljs-string">&quot;token-classification&quot;</span>, <span class="hljs-string">&quot;question-answering&quot;</span>]`}}),{c(){u=l("meta"),X=m(),c=l("h1"),w=l("a"),q=l("span"),x(g.$$.fragment),_=m(),A=l("span"),E=a("Export a model to ONNX with optimum.exporters.onnx"),H=m(),y=l("p"),te=a(`If you need to deploy \u{1F917} Transformers models in production environments, we recommend
exporting them to a serialized format that can be loaded and executed on specialized
runtimes and hardware. In this guide, we\u2019ll show you how to export \u{1F917} Transformers
models to `),j=l("a"),F=a("ONNX (Open Neural Network eXchange)"),oe=a("."),K=m(),P=l("p"),f=a(`ONNX is an open standard that defines a common set of operators and a common file format
to represent deep learning models in a wide variety of frameworks, including PyTorch and
TensorFlow. When a model is exported to the ONNX format, these operators are used to
construct a computational graph (often called an `),k=l("em"),$e=a("intermediate representation"),D=a(`) which
represents the flow of data through the neural network.`),se=m(),R=l("p"),Dt=a(`By exposing a graph with standardized operators and data types, ONNX makes it easy to
switch between frameworks. For example, a model trained in PyTorch can be exported to
ONNX format and then imported in TensorRT or OpenVino.`),Ye=m(),x(Q.$$.fragment),Ue=m(),Ne=l("p"),Mt=a(`\u{1F917} Optimum provides support for the ONNX export by leveraging configuration objects.
These configuration objects come ready made for a number of model architectures, and are
designed to be easily extendable to other architectures.`),We=m(),ve=l("p"),ae=l("strong"),It=a("To check the supported architectures, go to the "),be=l("a"),Ct=a("configuration reference page"),zt=a("."),Ge=m(),S=l("h2"),B=l("a"),Fe=l("span"),x(ne.$$.fragment),Rt=m(),De=l("span"),St=a("Exporting a model to ONNX using the CLI"),Je=m(),Oe=l("p"),Lt=a(`To export a \u{1F917} Transformers model to ONNX, you\u2019ll first need to install some extra
dependencies:`),Ze=m(),x(re.$$.fragment),et=m(),V=l("p"),Ht=a("The "),Me=l("code"),Kt=a("optimum.exporters.onnx"),Qt=a(" package can then be used as a Python module:"),tt=m(),x(le.$$.fragment),ot=m(),Ee=l("p"),Bt=a("Exporting a checkpoint can be done as follows:"),st=m(),x(ie.$$.fragment),at=m(),ye=l("p"),Vt=a("You should see the following logs (along with potential logs from PyTorch / TensorFlow that were hidden here for clarity):"),nt=m(),x(pe.$$.fragment),rt=m(),Y=l("p"),Yt=a("This exports an ONNX graph of the checkpoint defined by the "),Ie=l("code"),Ut=a("--model"),Wt=a(` argument.
As you can see, the task was automatically detected. This was possible because the model was on the Hub.`),lt=m(),U=l("p"),Gt=a("For local models, providing the "),Ce=l("code"),Jt=a("--task"),Zt=a(" argument is needed or it will default to the model architecture without any task specific head:"),it=m(),x(me.$$.fragment),pt=m(),W=l("p"),eo=a("Note that providing the "),ze=l("code"),to=a("--task"),oo=a(" argument for a model on the Hub will disable the automatic task detection."),mt=m(),T=l("p"),so=a("The resulting "),Re=l("code"),ao=a("model.onnx"),no=a(" file can then be run on one of the "),de=l("a"),ro=a(`many
accelerators`),lo=a(` that support the ONNX
standard. For example, we can load and run the model with `),ue=l("a"),io=a(`ONNX
Runtime`),po=a(" using the "),Se=l("code"),mo=a("optimum.onnxruntime"),uo=a(" package as follows:"),dt=m(),x(he.$$.fragment),ut=m(),Te=l("p"),ho=a("Printing the outputs would give that:"),ht=m(),x(fe.$$.fragment),ft=m(),qe=l("p"),fo=a("As you can see, converting a model to ONNX does not mean leaving the Hugging Face ecosystem. You end up with a similar API as regular \u{1F917} Transformers models!"),ct=m(),x(G.$$.fragment),gt=m(),J=l("p"),co=a("The process is identical for TensorFlow checkpoints on the Hub. For example, we can export a pure TensorFlow checkpoint from the "),ce=l("a"),go=a(`Keras
organization`),_o=a(" as follows:"),_t=m(),x(ge.$$.fragment),wt=m(),L=l("h2"),Z=l("a"),Le=l("span"),x(_e.$$.fragment),wo=m(),He=l("span"),ko=a("Selecting a task"),kt=m(),M=l("p"),xo=a("Each configuration comes with a set of "),Ke=l("em"),$o=a("tasks"),No=a(` that enable you to export models for different types of tasks. You can
check the list of supported tasks for both PyTorch and TensorFlow `),Ae=l("a"),vo=a("here"),bo=a("."),xt=m(),ee=l("p"),Oo=a(`For each configuration, you can find the list of supported tasks via the
`),Pe=l("a"),Eo=a("TasksManager"),yo=a(". For example, for DistilBERT, for the ONNX export, we have:"),$t=m(),x(we.$$.fragment),Nt=m(),I=l("p"),To=a("You can then pass one of these tasks to the "),Qe=l("code"),qo=a("--task"),Ao=a(" argument in the "),Be=l("code"),Po=a("optimum.exporters.onnx"),Xo=a(" package CLI, as mentioned above."),this.h()},l(e){const s=_s('[data-svelte="svelte-1phssyn"]',document.head);u=i(s,"META",{name:!0,content:!0}),s.forEach(t),X=d(e),c=i(e,"H1",{class:!0});var ke=p(c);w=i(ke,"A",{id:!0,class:!0,href:!0});var Ve=p(w);q=i(Ve,"SPAN",{});var Fo=p(q);$(g.$$.fragment,Fo),Fo.forEach(t),Ve.forEach(t),_=d(ke),A=i(ke,"SPAN",{});var Do=p(A);E=n(Do,"Export a model to ONNX with optimum.exporters.onnx"),Do.forEach(t),ke.forEach(t),H=d(e),y=i(e,"P",{});var bt=p(y);te=n(bt,`If you need to deploy \u{1F917} Transformers models in production environments, we recommend
exporting them to a serialized format that can be loaded and executed on specialized
runtimes and hardware. In this guide, we\u2019ll show you how to export \u{1F917} Transformers
models to `),j=i(bt,"A",{href:!0,rel:!0});var Mo=p(j);F=n(Mo,"ONNX (Open Neural Network eXchange)"),Mo.forEach(t),oe=n(bt,"."),bt.forEach(t),K=d(e),P=i(e,"P",{});var Ot=p(P);f=n(Ot,`ONNX is an open standard that defines a common set of operators and a common file format
to represent deep learning models in a wide variety of frameworks, including PyTorch and
TensorFlow. When a model is exported to the ONNX format, these operators are used to
construct a computational graph (often called an `),k=i(Ot,"EM",{});var Io=p(k);$e=n(Io,"intermediate representation"),Io.forEach(t),D=n(Ot,`) which
represents the flow of data through the neural network.`),Ot.forEach(t),se=d(e),R=i(e,"P",{});var Co=p(R);Dt=n(Co,`By exposing a graph with standardized operators and data types, ONNX makes it easy to
switch between frameworks. For example, a model trained in PyTorch can be exported to
ONNX format and then imported in TensorRT or OpenVino.`),Co.forEach(t),Ye=d(e),$(Q.$$.fragment,e),Ue=d(e),Ne=i(e,"P",{});var zo=p(Ne);Mt=n(zo,`\u{1F917} Optimum provides support for the ONNX export by leveraging configuration objects.
These configuration objects come ready made for a number of model architectures, and are
designed to be easily extendable to other architectures.`),zo.forEach(t),We=d(e),ve=i(e,"P",{});var Ro=p(ve);ae=i(Ro,"STRONG",{});var Et=p(ae);It=n(Et,"To check the supported architectures, go to the "),be=i(Et,"A",{href:!0});var So=p(be);Ct=n(So,"configuration reference page"),So.forEach(t),zt=n(Et,"."),Et.forEach(t),Ro.forEach(t),Ge=d(e),S=i(e,"H2",{class:!0});var yt=p(S);B=i(yt,"A",{id:!0,class:!0,href:!0});var Lo=p(B);Fe=i(Lo,"SPAN",{});var Ho=p(Fe);$(ne.$$.fragment,Ho),Ho.forEach(t),Lo.forEach(t),Rt=d(yt),De=i(yt,"SPAN",{});var Ko=p(De);St=n(Ko,"Exporting a model to ONNX using the CLI"),Ko.forEach(t),yt.forEach(t),Je=d(e),Oe=i(e,"P",{});var Qo=p(Oe);Lt=n(Qo,`To export a \u{1F917} Transformers model to ONNX, you\u2019ll first need to install some extra
dependencies:`),Qo.forEach(t),Ze=d(e),$(re.$$.fragment,e),et=d(e),V=i(e,"P",{});var Tt=p(V);Ht=n(Tt,"The "),Me=i(Tt,"CODE",{});var Bo=p(Me);Kt=n(Bo,"optimum.exporters.onnx"),Bo.forEach(t),Qt=n(Tt," package can then be used as a Python module:"),Tt.forEach(t),tt=d(e),$(le.$$.fragment,e),ot=d(e),Ee=i(e,"P",{});var Vo=p(Ee);Bt=n(Vo,"Exporting a checkpoint can be done as follows:"),Vo.forEach(t),st=d(e),$(ie.$$.fragment,e),at=d(e),ye=i(e,"P",{});var Yo=p(ye);Vt=n(Yo,"You should see the following logs (along with potential logs from PyTorch / TensorFlow that were hidden here for clarity):"),Yo.forEach(t),nt=d(e),$(pe.$$.fragment,e),rt=d(e),Y=i(e,"P",{});var qt=p(Y);Yt=n(qt,"This exports an ONNX graph of the checkpoint defined by the "),Ie=i(qt,"CODE",{});var Uo=p(Ie);Ut=n(Uo,"--model"),Uo.forEach(t),Wt=n(qt,` argument.
As you can see, the task was automatically detected. This was possible because the model was on the Hub.`),qt.forEach(t),lt=d(e),U=i(e,"P",{});var At=p(U);Gt=n(At,"For local models, providing the "),Ce=i(At,"CODE",{});var Wo=p(Ce);Jt=n(Wo,"--task"),Wo.forEach(t),Zt=n(At," argument is needed or it will default to the model architecture without any task specific head:"),At.forEach(t),it=d(e),$(me.$$.fragment,e),pt=d(e),W=i(e,"P",{});var Pt=p(W);eo=n(Pt,"Note that providing the "),ze=i(Pt,"CODE",{});var Go=p(ze);to=n(Go,"--task"),Go.forEach(t),oo=n(Pt," argument for a model on the Hub will disable the automatic task detection."),Pt.forEach(t),mt=d(e),T=i(e,"P",{});var C=p(T);so=n(C,"The resulting "),Re=i(C,"CODE",{});var Jo=p(Re);ao=n(Jo,"model.onnx"),Jo.forEach(t),no=n(C," file can then be run on one of the "),de=i(C,"A",{href:!0,rel:!0});var Zo=p(de);ro=n(Zo,`many
accelerators`),Zo.forEach(t),lo=n(C,` that support the ONNX
standard. For example, we can load and run the model with `),ue=i(C,"A",{href:!0,rel:!0});var es=p(ue);io=n(es,`ONNX
Runtime`),es.forEach(t),po=n(C," using the "),Se=i(C,"CODE",{});var ts=p(Se);mo=n(ts,"optimum.onnxruntime"),ts.forEach(t),uo=n(C," package as follows:"),C.forEach(t),dt=d(e),$(he.$$.fragment,e),ut=d(e),Te=i(e,"P",{});var os=p(Te);ho=n(os,"Printing the outputs would give that:"),os.forEach(t),ht=d(e),$(fe.$$.fragment,e),ft=d(e),qe=i(e,"P",{});var ss=p(qe);fo=n(ss,"As you can see, converting a model to ONNX does not mean leaving the Hugging Face ecosystem. You end up with a similar API as regular \u{1F917} Transformers models!"),ss.forEach(t),ct=d(e),$(G.$$.fragment,e),gt=d(e),J=i(e,"P",{});var Xt=p(J);co=n(Xt,"The process is identical for TensorFlow checkpoints on the Hub. For example, we can export a pure TensorFlow checkpoint from the "),ce=i(Xt,"A",{href:!0,rel:!0});var as=p(ce);go=n(as,`Keras
organization`),as.forEach(t),_o=n(Xt," as follows:"),Xt.forEach(t),_t=d(e),$(ge.$$.fragment,e),wt=d(e),L=i(e,"H2",{class:!0});var jt=p(L);Z=i(jt,"A",{id:!0,class:!0,href:!0});var ns=p(Z);Le=i(ns,"SPAN",{});var rs=p(Le);$(_e.$$.fragment,rs),rs.forEach(t),ns.forEach(t),wo=d(jt),He=i(jt,"SPAN",{});var ls=p(He);ko=n(ls,"Selecting a task"),ls.forEach(t),jt.forEach(t),kt=d(e),M=i(e,"P",{});var Xe=p(M);xo=n(Xe,"Each configuration comes with a set of "),Ke=i(Xe,"EM",{});var is=p(Ke);$o=n(is,"tasks"),is.forEach(t),No=n(Xe,` that enable you to export models for different types of tasks. You can
check the list of supported tasks for both PyTorch and TensorFlow `),Ae=i(Xe,"A",{href:!0});var ps=p(Ae);vo=n(ps,"here"),ps.forEach(t),bo=n(Xe,"."),Xe.forEach(t),xt=d(e),ee=i(e,"P",{});var Ft=p(ee);Oo=n(Ft,`For each configuration, you can find the list of supported tasks via the
`),Pe=i(Ft,"A",{href:!0});var ms=p(Pe);Eo=n(ms,"TasksManager"),ms.forEach(t),yo=n(Ft,". For example, for DistilBERT, for the ONNX export, we have:"),Ft.forEach(t),$t=d(e),$(we.$$.fragment,e),Nt=d(e),I=i(e,"P",{});var je=p(I);To=n(je,"You can then pass one of these tasks to the "),Qe=i(je,"CODE",{});var ds=p(Qe);qo=n(ds,"--task"),ds.forEach(t),Ao=n(je," argument in the "),Be=i(je,"CODE",{});var us=p(Be);Po=n(us,"optimum.exporters.onnx"),us.forEach(t),Xo=n(je," package CLI, as mentioned above."),je.forEach(t),this.h()},h(){h(u,"name","hf:doc:metadata"),h(u,"content",JSON.stringify(vs)),h(w,"id","export-a-model-to-onnx-with-optimumexportersonnx"),h(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(w,"href","#export-a-model-to-onnx-with-optimumexportersonnx"),h(c,"class","relative group"),h(j,"href","http://onnx.ai"),h(j,"rel","nofollow"),h(be,"href","../package_reference/configuration#supported-architectures"),h(B,"id","exporting-a-model-to-onnx-using-the-cli"),h(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(B,"href","#exporting-a-model-to-onnx-using-the-cli"),h(S,"class","relative group"),h(de,"href","https://onnx.ai/supported-tools.html#deployModel"),h(de,"rel","nofollow"),h(ue,"href","https://onnxruntime.ai/"),h(ue,"rel","nofollow"),h(ce,"href","https://huggingface.co/keras-io"),h(ce,"rel","nofollow"),h(Z,"id","selecting-a-task"),h(Z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Z,"href","#selecting-a-task"),h(L,"class","relative group"),h(Ae,"href","/exporters/task_manager"),h(Pe,"href","/docs/optimum/main/en/exporters/task_manager#optimum.exporters.TasksManager")},m(e,s){o(document.head,u),r(e,X,s),r(e,c,s),o(c,w),o(w,q),N(g,q,null),o(c,_),o(c,A),o(A,E),r(e,H,s),r(e,y,s),o(y,te),o(y,j),o(j,F),o(y,oe),r(e,K,s),r(e,P,s),o(P,f),o(P,k),o(k,$e),o(P,D),r(e,se,s),r(e,R,s),o(R,Dt),r(e,Ye,s),N(Q,e,s),r(e,Ue,s),r(e,Ne,s),o(Ne,Mt),r(e,We,s),r(e,ve,s),o(ve,ae),o(ae,It),o(ae,be),o(be,Ct),o(ae,zt),r(e,Ge,s),r(e,S,s),o(S,B),o(B,Fe),N(ne,Fe,null),o(S,Rt),o(S,De),o(De,St),r(e,Je,s),r(e,Oe,s),o(Oe,Lt),r(e,Ze,s),N(re,e,s),r(e,et,s),r(e,V,s),o(V,Ht),o(V,Me),o(Me,Kt),o(V,Qt),r(e,tt,s),N(le,e,s),r(e,ot,s),r(e,Ee,s),o(Ee,Bt),r(e,st,s),N(ie,e,s),r(e,at,s),r(e,ye,s),o(ye,Vt),r(e,nt,s),N(pe,e,s),r(e,rt,s),r(e,Y,s),o(Y,Yt),o(Y,Ie),o(Ie,Ut),o(Y,Wt),r(e,lt,s),r(e,U,s),o(U,Gt),o(U,Ce),o(Ce,Jt),o(U,Zt),r(e,it,s),N(me,e,s),r(e,pt,s),r(e,W,s),o(W,eo),o(W,ze),o(ze,to),o(W,oo),r(e,mt,s),r(e,T,s),o(T,so),o(T,Re),o(Re,ao),o(T,no),o(T,de),o(de,ro),o(T,lo),o(T,ue),o(ue,io),o(T,po),o(T,Se),o(Se,mo),o(T,uo),r(e,dt,s),N(he,e,s),r(e,ut,s),r(e,Te,s),o(Te,ho),r(e,ht,s),N(fe,e,s),r(e,ft,s),r(e,qe,s),o(qe,fo),r(e,ct,s),N(G,e,s),r(e,gt,s),r(e,J,s),o(J,co),o(J,ce),o(ce,go),o(J,_o),r(e,_t,s),N(ge,e,s),r(e,wt,s),r(e,L,s),o(L,Z),o(Z,Le),N(_e,Le,null),o(L,wo),o(L,He),o(He,ko),r(e,kt,s),r(e,M,s),o(M,xo),o(M,Ke),o(Ke,$o),o(M,No),o(M,Ae),o(Ae,vo),o(M,bo),r(e,xt,s),r(e,ee,s),o(ee,Oo),o(ee,Pe),o(Pe,Eo),o(ee,yo),r(e,$t,s),N(we,e,s),r(e,Nt,s),r(e,I,s),o(I,To),o(I,Qe),o(Qe,qo),o(I,Ao),o(I,Be),o(Be,Po),o(I,Xo),vt=!0},p(e,[s]){const ke={};s&2&&(ke.$$scope={dirty:s,ctx:e}),Q.$set(ke);const Ve={};s&2&&(Ve.$$scope={dirty:s,ctx:e}),G.$set(Ve)},i(e){vt||(v(g.$$.fragment,e),v(Q.$$.fragment,e),v(ne.$$.fragment,e),v(re.$$.fragment,e),v(le.$$.fragment,e),v(ie.$$.fragment,e),v(pe.$$.fragment,e),v(me.$$.fragment,e),v(he.$$.fragment,e),v(fe.$$.fragment,e),v(G.$$.fragment,e),v(ge.$$.fragment,e),v(_e.$$.fragment,e),v(we.$$.fragment,e),vt=!0)},o(e){b(g.$$.fragment,e),b(Q.$$.fragment,e),b(ne.$$.fragment,e),b(re.$$.fragment,e),b(le.$$.fragment,e),b(ie.$$.fragment,e),b(pe.$$.fragment,e),b(me.$$.fragment,e),b(he.$$.fragment,e),b(fe.$$.fragment,e),b(G.$$.fragment,e),b(ge.$$.fragment,e),b(_e.$$.fragment,e),b(we.$$.fragment,e),vt=!1},d(e){t(u),e&&t(X),e&&t(c),O(g),e&&t(H),e&&t(y),e&&t(K),e&&t(P),e&&t(se),e&&t(R),e&&t(Ye),O(Q,e),e&&t(Ue),e&&t(Ne),e&&t(We),e&&t(ve),e&&t(Ge),e&&t(S),O(ne),e&&t(Je),e&&t(Oe),e&&t(Ze),O(re,e),e&&t(et),e&&t(V),e&&t(tt),O(le,e),e&&t(ot),e&&t(Ee),e&&t(st),O(ie,e),e&&t(at),e&&t(ye),e&&t(nt),O(pe,e),e&&t(rt),e&&t(Y),e&&t(lt),e&&t(U),e&&t(it),O(me,e),e&&t(pt),e&&t(W),e&&t(mt),e&&t(T),e&&t(dt),O(he,e),e&&t(ut),e&&t(Te),e&&t(ht),O(fe,e),e&&t(ft),e&&t(qe),e&&t(ct),O(G,e),e&&t(gt),e&&t(J),e&&t(_t),O(ge,e),e&&t(wt),e&&t(L),O(_e),e&&t(kt),e&&t(M),e&&t(xt),e&&t(ee),e&&t($t),O(we,e),e&&t(Nt),e&&t(I)}}}const vs={local:"export-a-model-to-onnx-with-optimumexportersonnx",sections:[{local:"exporting-a-model-to-onnx-using-the-cli",title:"Exporting a model to ONNX using the CLI"},{local:"selecting-a-task",title:"Selecting a task"}],title:"Export a model to ONNX with optimum.exporters.onnx"};function bs(xe){return ws(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class qs extends fs{constructor(u){super();cs(this,u,bs,Ns,gs,{})}}export{qs as default,vs as metadata};
